import * as AST from './AST';
export type FunctionTableEntry = AST.NodeFunction;
export interface VariableTableEntry {
    type: number;
    parameter?: AST.NodeIdentifier[];
    expression?: AST.NodeExpr;
}
export declare class SymbolTable {
    static readonly NAME = 1;
    static readonly FUNCTION_HANDLER = 2;
    static readonly ANON_FUNCTION_HANDLER = 3;
    variableTable: Record<string, VariableTableEntry>;
    functionTable: Record<string, FunctionTableEntry>;
    parent: SymbolTable | null;
    child: SymbolTable[];
    scope: string | null;
    constructor(parent?: SymbolTable | null, scope?: string | null, node?: any);
    lookupVariable(id: string): [VariableTableEntry, string | null] | null;
    insertVariable(id: string, expression: AST.NodeExpr, parameter?: AST.NodeIdentifier[]): [VariableTableEntry, string | null];
    lookupFunction(id: string): [FunctionTableEntry, string | null] | null;
    insertFunction(id: string, entry: FunctionTableEntry): [FunctionTableEntry, string | null];
}
